
cvx_begin
    cvx_quiet(true);
    %     cvx_precision([.0001 .0001 .0001]);
    cvx_solver sdpt3

    variable fw1(p);
    variable epsilon1pos(w1);
    variable epsilon1neg(w2);
    variable b;
    variable t1;
    expression fwDv1(p);

    for i=1:p
        fwDv1(i) = norm(fw1(affs{i}),rhonorm);
    end

    %     minimize 0.5*square(t1) + sum(epsilon1)/lambda
    minimize 0.5*square(t1) + (w2/n)*sum(epsilon1pos)/lambda + (w1/n)*sum(epsilon1neg)/lambda
    subject to
    epsilon1pos >= 1-(X(pos,:)*fw1+b).*Y1(pos);
    epsilon1neg >= 1-(X(neg,:)*fw1+b).*Y1(neg);
    epsilon1pos >= 0;
    epsilon1neg >= 0;
    sum(fwDv1.*weights) <= t1;

cvx_end